package protocol;

import java.util.Random;

import multicast.*;
import constants.Constants;
import file_system.*;

public class Reclaim_space_2 extends Thread {
	String file_id;
	int chunk_number;
	boolean temp_1;

	public Reclaim_space_2(String file_id, int chunk_number) {
		this.file_id = file_id;
		this.chunk_number = chunk_number;
		temp_1 = false;
	}

	public Reclaim_space_2()
	{
		file_id=null;
		chunk_number = -1;
		temp_1 = true;
	}

	public void run()
	{
		if(!(temp_1))
		{
			remove_proccess();
		}
		else
		{
			free_space();
		}
	}

	private void free_space() {
		Chunk_duplications chunk_duplications = Chunk_duplications.chunk_duplications.get(0);
		if(chunk_duplications == null)
		{
			System.out.println("No chunks, no free space.");
			return;
		}
		int difference_1 = chunk_duplications.get_current_duplication_degree() - chunk_duplications.get_duplication_degree();
		for(int i=1; i < Chunk_duplications.chunk_duplications.size();i++)
		{
			Chunk_duplications current = Chunk_duplications.chunk_duplications.get(i);
			int difference_2 = current.get_current_duplication_degree() - current.get_duplication_degree();

			if( difference_2 > difference_1 )
				chunk_duplications = current;
		}
		String packet = "REMOVED " + Constants.INITIAL_VERSION + " " + chunk_duplications.get_file_id() + " " + chunk_duplications.get_chunk_number() + Constants.CRLF()+Constants.CRLF();
		Channel_1.MC().send(packet);
		Chunk chunk_delete = Stored_files.get_stored_files().get_file(chunk_duplications.get_file_id()).get_chunk(chunk_duplications.get_chunk_number());
		Stored_files.get_stored_files().get_file(chunk_duplications.get_file_id()).delete_chunk(chunk_duplications.get_chunk_number());
		Stored_files.delete_chunk(chunk_delete);
		System.out.println("Deleted chunk " + chunk_duplications.get_chunk_number() + " from " + chunk_duplications.get_file_id());
	}

	private void remove_proccess() {
		Chunk chunk_delete = Stored_files.get_stored_files().get_file(file_id).get_chunk(chunk_number);
		if(chunk_delete == null)
		{
			return;
		}
		chunk_delete.delete();
		if( chunk_delete.get_current_duplication_degree() < chunk_delete.get_duplication_degree())
		{
			Reclaim_space_1.add_chunk(chunk_delete);
			Random random = new Random();
			synchronized(this)
			{
				try {
					wait(random.nextInt(400));
				} catch (InterruptedException e) {
					e.printStackTrace();
					return;
				}
			}
			if(Reclaim_space_1.chunk_already_in(chunk_delete))
			{
				Protocol.send_chunk(chunk_delete);
			}
		}
	}
}
