package file_system;

public class Chunk {
        private String file_id;
        private int chunk_number, duplication_degree, current_duplication_degree;
        private String data;
       
        public Chunk(String file_id_temp, int chunk_number_temp, String data, int duplication_degree_temp){
                file_id = file_id_temp;
                chunk_number = chunk_number_temp;
                this.data = data;
                duplication_degree = duplication_degree_temp;
                current_duplication_degree=1;
        }
       
        public void set_current_duplication_degree(int duplication)
        {
        	current_duplication_degree= duplication;
        }
       
        public void store()
        {
        	current_duplication_degree++;
        }
       
        public void delete()
        {
        	current_duplication_degree--;
        }

        public String get_file_id() {
                return file_id;
        }

        public int get_chunk_number() {
                return chunk_number;
        }

        public String get_data() {
                return data;
        }
       
        public int get_duplication_degree()
        {
                return duplication_degree;
        }
       
        public int get_current_duplication_degree()
        {
                return current_duplication_degree;
        }

        public void restart_duplication_degree() {
        	current_duplication_degree = 1;
        }
       
        public void start_duplication_degree(){
        	current_duplication_degree=0;
        }
}