package file_system;

import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.io.Serializable;
import java.util.ArrayList;

public class Chunk_duplications implements Serializable {

	private static final long serialVersionUID = -42L;
	private int duplication_degree, current_duplication, chunk_number;
	private String file_id;

	public static ArrayList<Chunk_duplications> chunk_duplications = new ArrayList<Chunk_duplications>();

	public static void stored_duplications()
	{
		try {
			OutputStream file = new FileOutputStream("stored_files/duplications");
			OutputStream buffer = new BufferedOutputStream( file );
			ObjectOutput output = new ObjectOutputStream( buffer );
			try{
				output.writeObject(chunk_duplications);
			}
			finally{
				output.close();
			}
		} catch (IOException e) {
			System.out.println("Error in Chunk_duplications.java #01");
		}
	}

	public Chunk_duplications(String file_id, int chunk_number, int duplication_degree, int current_duplication)
	{
		this.file_id = file_id;
		this.chunk_number=chunk_number;
		this.current_duplication=current_duplication;
		this.duplication_degree=duplication_degree;
	}

	public String get_file_id()
	{
		return file_id;
	}

	public int get_current_duplication_degree() {
		return current_duplication;
	}

	public int get_duplication_degree() {
		return duplication_degree;
	}

	public int get_chunk_number() {
		return chunk_number;
	}

	public static void delete_duplication(String file_id, int chunk_number) {

		for(int i=0;i<chunk_duplications.size();i++)
		{
			if( chunk_duplications.get(i).get_file_id().equals(file_id) && chunk_duplications.get(i).get_chunk_number() == chunk_number )
			{
				chunk_duplications.remove(i);
				return;
			}
		}
	}

}