package multicast;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.MulticastSocket;

import constants.Constants;

public class Channel_1 {
	private static MulticastSocket socket = null;
	private static Channel_1 channel = new Channel_1();

	private Channel_1()
	{
		try {
			socket = new MulticastSocket(Constants.MC_PORT);
			socket.joinGroup(Constants.MC_ADDRESS());
			Channel_2 listener = new Channel_2(socket);
			listener.start();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	 public static Channel_1 MC()
	 {
		 return channel;
	 }

	 public void send(String packet)
	 {
		 try {
			 byte[] message = packet.getBytes();
			 DatagramPacket packet_temp = new DatagramPacket(message,message.length,Constants.MC_ADDRESS(),Constants.MC_PORT);
			 socket.send(packet_temp);
		 } catch (IOException e) {

			 e.printStackTrace();
		 }
	 }
}