package multicast;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.MulticastSocket;

import protocol.*;
import constants.Constants;

public class Stored_data_2 extends Thread{

	private MulticastSocket socket;

	public Stored_data_2(MulticastSocket socket)
	{
		this.socket = socket;
	}

	public void run() {
		while( true )
		{
			try {
				DatagramPacket packet = new DatagramPacket(new byte[Constants.PACKET_MAX_SIZE], Constants.PACKET_MAX_SIZE);
				socket.receive(packet);
				String packet_temp = new String(packet.getData());
				packet_temp = packet_temp.trim();
				Protocol.get_protocol().process(packet_temp);
			} catch (IOException e) {
				e.printStackTrace();
			} 
		}  
	}   
}